Loading...
Searching...
No Matches
ON_Xform Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_xform.h>`

## Public Member Functions

| ON_Xform ()
| ON_Xform (int)
| ON_Xform (double)
| ON_Xform (const double[4][4])
| ON_Xform (const float[4][4])
| ON_Xform (const double *)
| ON_Xform (const float *)
| ON_Xform (const ON_Matrix &)
| ON_Xform (const ON_3dPoint &P, const ON_3dVector &X, const ON_3dVector &Y, const ON_3dVector &Z)
double * | operator[] (int)
const double * | operator[] (int) const
ON_Xform & | operator= (int)
ON_Xform & | operator= (float)
ON_Xform & | operator= (double)
ON_Xform & | operator= (const ON_Matrix &)
ON_2dPoint | operator* (const ON_2dPoint &) const
ON_3dPoint | operator* (const ON_3dPoint &) const
ON_4dPoint | operator* (const ON_4dPoint &) const
ON_2dVector | operator* (const ON_2dVector &) const
ON_3dVector | operator* (const ON_3dVector &) const
ON_Xform | operator* (const ON_Xform &) const
ON_Xform | operator+ (const ON_Xform &) const
ON_Xform | operator- (const ON_Xform &) const
bool | IsValid () const
bool | IsIdentity (double zero_tolerance=0.0) const
bool | IsNotIdentity (double zero_tolerance=0.0) const
bool | IsTranslation (double zero_tolerance=0.0) const
bool | IsZero () const
int | IsSimilarity () const
int | Compare (const ON_Xform &other) const
void | Transpose ()
int | Rank (double *=NULL) const
double | Determinant (double *=NULL) const
bool | Invert (double *=NULL)
ON_Xform | Inverse (double *=NULL) const
double | GetSurfaceNormalXform (ON_Xform &N_xform) const
double | GetMappingXforms (ON_Xform &P_xform, ON_Xform &N_xform) const
void | ActOnLeft (double, double, double, double, double[4]) const
void | ActOnRight (double, double, double, double, double[4]) const
void | Zero ()
void | Identity ()
void | Diagonal (double)
void | Scale (double x_scale_factor, double y_scale_factor, double z_scale_factor)
void | Scale (const ON_3dVector &scale_vector)
void | Scale (ON_3dPoint fixed_point, double scale_factor)
void | Scale (const ON_Plane &plane, double x_scale_factor, double y_scale_factor, double z_scale_factor)
void | Shear (const ON_Plane &plane, const ON_3dVector &x1, const ON_3dVector &y1, const ON_3dVector &z1)
void | Translation (const ON_3dVector &)
void | Translation (double, double, double)
void | PlanarProjection (const ON_Plane &plane)
void | Rotation (double sin_angle, double cos_angle, ON_3dVector rotation_axis, ON_3dPoint rotation_center)
void | Rotation (double angle_radians, ON_3dVector rotation_axis, ON_3dPoint rotation_center)
void | Rotation (ON_3dVector start_dir, ON_3dVector end_dir, ON_3dPoint rotation_center)
void | Rotation (const ON_3dVector &X0, const ON_3dVector &Y0, const ON_3dVector &Z0, const ON_3dVector &X1, const ON_3dVector &Y1, const ON_3dVector &Z1)
void | Rotation (const ON_3dPoint &P0, const ON_3dVector &X0, const ON_3dVector &Y0, const ON_3dVector &Z0, const ON_3dPoint &P1, const ON_3dVector &X1, const ON_3dVector &Y1, const ON_3dVector &Z1)
void | Rotation (const ON_Plane &plane0, const ON_Plane &plane1)
void | Mirror (ON_3dPoint point_on_mirror_plane, ON_3dVector normal_to_mirror_plane)
bool | ChangeBasis (const ON_Plane &plane0, const ON_Plane &plane1)
bool | ChangeBasis (const ON_3dVector &X0, const ON_3dVector &Y0, const ON_3dVector &Z0, const ON_3dVector &X1, const ON_3dVector &Y1, const ON_3dVector &Z1)
bool | ChangeBasis (const ON_3dPoint &P0, const ON_3dVector &X0, const ON_3dVector &Y0, const ON_3dVector &Z0, const ON_3dPoint &P1, const ON_3dVector &X1, const ON_3dVector &Y1, const ON_3dVector &Z1)
void | WorldToCamera (const ON_3dPoint &, const ON_3dVector &, const ON_3dVector &, const ON_3dVector &)
void | CameraToWorld (const ON_3dPoint &, const ON_3dVector &, const ON_3dVector &, const ON_3dVector &)
bool | CameraToClip (ON_BOOL32, double, double, double, double, double, double)
bool | ClipToCamera (int, double, double, double, double, double, double)
bool | ClipToScreen (double, double, double, double, double, double)
bool | ScreenToClip (double, double, double, double, double, double)
int | ClipFlag4d (const double *) const
int | ClipFlag4d (int, int, const double *, ON_BOOL32=true) const
int | ClipFlag3d (const double *) const
int | ClipFlag3d (int, int, const double *, ON_BOOL32=true) const
int | ClipFlag3dBox (const double *, const double *) const
bool | IntervalChange (int dir, ON_Interval old_interval, ON_Interval new_interval)

## Public Attributes

double | m_xform [4][4]

## Detailed Description

Definition at line 28 of file opennurbs_xform.h.

## Constructor & Destructor Documentation

## ON_Xform() [1/9]

ON_Xform::ON_Xform | ( |  | ) |

## ON_Xform() [2/9]

ON_Xform::ON_Xform | ( | int |  | ) |

## ON_Xform() [3/9]

ON_Xform::ON_Xform | ( | double |  | ) |

## ON_Xform() [4/9]

ON_Xform::ON_Xform | ( | const double | [4][4] | ) |

## ON_Xform() [5/9]

ON_Xform::ON_Xform | ( | const float | [4][4] | ) |

## ON_Xform() [6/9]

ON_Xform::ON_Xform | ( | const double * |  | ) |

## ON_Xform() [7/9]

ON_Xform::ON_Xform | ( | const float * |  | ) |

## ON_Xform() [8/9]

ON_Xform::ON_Xform | ( | const ON_Matrix & |  | ) |

## ON_Xform() [9/9]

ON_Xform::ON_Xform | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | X,
|  | const ON_3dVector & | Y,
|  | const ON_3dVector & | Z
| ) |  |

## Member Function Documentation

## ActOnLeft()

void ON_Xform::ActOnLeft | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | [4]
| ) |  | const

## ActOnRight()

void ON_Xform::ActOnRight | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | [4]
| ) |  | const

## CameraToClip()

bool ON_Xform::CameraToClip | ( | ON_BOOL32 | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |

## CameraToWorld()

void ON_Xform::CameraToWorld | ( | const ON_3dPoint & | ,
|  | const ON_3dVector & | ,
|  | const ON_3dVector & | ,
|  | const ON_3dVector & |
| ) |  |

## ChangeBasis() [1/3]

bool ON_Xform::ChangeBasis | ( | const ON_3dPoint & | P0,
|  | const ON_3dVector & | X0,
|  | const ON_3dVector & | Y0,
|  | const ON_3dVector & | Z0,
|  | const ON_3dPoint & | P1,
|  | const ON_3dVector & | X1,
|  | const ON_3dVector & | Y1,
|  | const ON_3dVector & | Z1
| ) |  |

## ChangeBasis() [2/3]

bool ON_Xform::ChangeBasis | ( | const ON_3dVector & | X0,
|  | const ON_3dVector & | Y0,
|  | const ON_3dVector & | Z0,
|  | const ON_3dVector & | X1,
|  | const ON_3dVector & | Y1,
|  | const ON_3dVector & | Z1
| ) |  |

## ChangeBasis() [3/3]

bool ON_Xform::ChangeBasis | ( | const ON_Plane & | plane0,
|  | const ON_Plane & | plane1
| ) |  |

## ClipFlag3d() [1/2]

int ON_Xform::ClipFlag3d | ( | const double * |  | ) | const

## ClipFlag3d() [2/2]

int ON_Xform::ClipFlag3d | ( | int | ,
|  | int | ,
|  | const double * | ,
|  | ON_BOOL32 | = `true`
| ) |  | const

## ClipFlag3dBox()

int ON_Xform::ClipFlag3dBox | ( | const double * | ,
|  | const double * |
| ) |  | const

## ClipFlag4d() [1/2]

int ON_Xform::ClipFlag4d | ( | const double * |  | ) | const

## ClipFlag4d() [2/2]

int ON_Xform::ClipFlag4d | ( | int | ,
|  | int | ,
|  | const double * | ,
|  | ON_BOOL32 | = `true`
| ) |  | const

## ClipToCamera()

bool ON_Xform::ClipToCamera | ( | int | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |

## ClipToScreen()

bool ON_Xform::ClipToScreen | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |

## Compare()

int ON_Xform::Compare | ( | const ON_Xform & | other | ) | const

## Determinant()

double ON_Xform::Determinant | ( | double * | = `NULL` | ) | const

## Diagonal()

void ON_Xform::Diagonal | ( | double |  | ) |

## GetMappingXforms()

double ON_Xform::GetMappingXforms | ( | ON_Xform & | P_xform,
|  | ON_Xform & | N_xform
| ) |  | const

## GetSurfaceNormalXform()

double ON_Xform::GetSurfaceNormalXform | ( | ON_Xform & | N_xform | ) | const

## Identity()

void ON_Xform::Identity | ( |  | ) |

## IntervalChange()

bool ON_Xform::IntervalChange | ( | int | dir,
|  | ON_Interval | old_interval,
|  | ON_Interval | new_interval
| ) |  |

## Inverse()

ON_Xform ON_Xform::Inverse | ( | double * | = `NULL` | ) | const

## Invert()

bool ON_Xform::Invert | ( | double * | = `NULL` | ) |

## IsIdentity()

bool ON_Xform::IsIdentity | ( | double | zero_tolerance = `0.0` | ) | const

## IsNotIdentity()

bool ON_Xform::IsNotIdentity | ( | double | zero_tolerance = `0.0` | ) | const

## IsSimilarity()

int ON_Xform::IsSimilarity | ( |  | ) | const

## IsTranslation()

bool ON_Xform::IsTranslation | ( | double | zero_tolerance = `0.0` | ) | const

## IsValid()

bool ON_Xform::IsValid | ( |  | ) | const

## IsZero()

bool ON_Xform::IsZero | ( |  | ) | const

## Mirror()

void ON_Xform::Mirror | ( | ON_3dPoint | point_on_mirror_plane,
|  | ON_3dVector | normal_to_mirror_plane
| ) |  |

## operator*() [1/6]

ON_2dPoint ON_Xform::operator* | ( | const ON_2dPoint & |  | ) | const

## operator*() [2/6]

ON_2dVector ON_Xform::operator* | ( | const ON_2dVector & |  | ) | const

## operator*() [3/6]

ON_3dPoint ON_Xform::operator* | ( | const ON_3dPoint & |  | ) | const

## operator*() [4/6]

ON_3dVector ON_Xform::operator* | ( | const ON_3dVector & |  | ) | const

## operator*() [5/6]

ON_4dPoint ON_Xform::operator* | ( | const ON_4dPoint & |  | ) | const

## operator*() [6/6]

ON_Xform ON_Xform::operator* | ( | const ON_Xform & |  | ) | const

## operator+()

ON_Xform ON_Xform::operator+ | ( | const ON_Xform & |  | ) | const

## operator-()

ON_Xform ON_Xform::operator- | ( | const ON_Xform & |  | ) | const

## operator=() [1/4]

ON_Xform & ON_Xform::operator= | ( | const ON_Matrix & |  | ) |

## operator=() [2/4]

ON_Xform & ON_Xform::operator= | ( | double |  | ) |

## operator=() [3/4]

ON_Xform & ON_Xform::operator= | ( | float |  | ) |

## operator=() [4/4]

ON_Xform & ON_Xform::operator= | ( | int |  | ) |

## operator[]() [1/2]

double * ON_Xform::operator[] | ( | int |  | ) |

## operator[]() [2/2]

const double * ON_Xform::operator[] | ( | int |  | ) | const

## PlanarProjection()

void ON_Xform::PlanarProjection | ( | const ON_Plane & | plane | ) |

## Rank()

int ON_Xform::Rank | ( | double * | = `NULL` | ) | const

## Rotation() [1/6]

void ON_Xform::Rotation | ( | const ON_3dPoint & | P0,
|  | const ON_3dVector & | X0,
|  | const ON_3dVector & | Y0,
|  | const ON_3dVector & | Z0,
|  | const ON_3dPoint & | P1,
|  | const ON_3dVector & | X1,
|  | const ON_3dVector & | Y1,
|  | const ON_3dVector & | Z1
| ) |  |

## Rotation() [2/6]

void ON_Xform::Rotation | ( | const ON_3dVector & | X0,
|  | const ON_3dVector & | Y0,
|  | const ON_3dVector & | Z0,
|  | const ON_3dVector & | X1,
|  | const ON_3dVector & | Y1,
|  | const ON_3dVector & | Z1
| ) |  |

## Rotation() [3/6]

void ON_Xform::Rotation | ( | const ON_Plane & | plane0,
|  | const ON_Plane & | plane1
| ) |  |

## Rotation() [4/6]

void ON_Xform::Rotation | ( | double | angle_radians,
|  | ON_3dVector | rotation_axis,
|  | ON_3dPoint | rotation_center
| ) |  |

## Rotation() [5/6]

void ON_Xform::Rotation | ( | double | sin_angle,
|  | double | cos_angle,
|  | ON_3dVector | rotation_axis,
|  | ON_3dPoint | rotation_center
| ) |  |

## Rotation() [6/6]

void ON_Xform::Rotation | ( | ON_3dVector | start_dir,
|  | ON_3dVector | end_dir,
|  | ON_3dPoint | rotation_center
| ) |  |

## Scale() [1/4]

void ON_Xform::Scale | ( | const ON_3dVector & | scale_vector | ) |

## Scale() [2/4]

void ON_Xform::Scale | ( | const ON_Plane & | plane,
|  | double | x_scale_factor,
|  | double | y_scale_factor,
|  | double | z_scale_factor
| ) |  |

## Scale() [3/4]

void ON_Xform::Scale | ( | double | x_scale_factor,
|  | double | y_scale_factor,
|  | double | z_scale_factor
| ) |  |

## Scale() [4/4]

void ON_Xform::Scale | ( | ON_3dPoint | fixed_point,
|  | double | scale_factor
| ) |  |

## ScreenToClip()

bool ON_Xform::ScreenToClip | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |

## Shear()

void ON_Xform::Shear | ( | const ON_Plane & | plane,
|  | const ON_3dVector & | x1,
|  | const ON_3dVector & | y1,
|  | const ON_3dVector & | z1
| ) |  |

## Translation() [1/2]

void ON_Xform::Translation | ( | const ON_3dVector & |  | ) |

## Translation() [2/2]

void ON_Xform::Translation | ( | double | ,
|  | double | ,
|  | double |
| ) |  |

## Transpose()

void ON_Xform::Transpose | ( |  | ) |

## WorldToCamera()

void ON_Xform::WorldToCamera | ( | const ON_3dPoint & | ,
|  | const ON_3dVector & | ,
|  | const ON_3dVector & | ,
|  | const ON_3dVector & |
| ) |  |

## Zero()

void ON_Xform::Zero | ( |  | ) |

## Member Data Documentation

## m_xform

double ON_Xform::m_xform[4][4]

Definition at line 31 of file opennurbs_xform.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_xform.h